## ectrans 1.7.0

=== CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.25 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

project( ectrans LANGUAGES C CXX Fortran )
include( ectrans_macros )

# CMake 3.29 adds CMAKE_TEST_LAUNCHER defined either as CMake variable or environment.
# This launcher is a semi-colon-separted list of arguments that is used to launch serial tasks,
# and can be defined during the CMake configuration.
# This is e.g. required for GPU tests that need access to slurm resources:
#    export CMAKE_TEST_LAUNCHER="srun;-n;1"
# To run the tests then:
#    salloc -q <queue> --gpus-per-task=1 -n <nproc>    ctest <ctest-args>
# Before cmake 3.29 this could only be achieved with CMAKE_CROSSCOMPILING_EMULATOR.
# This next snippet ensures forward compatibility
if( ${CMAKE_VERSION} VERSION_LESS "3.29" )
  if( DEFINED CMAKE_TEST_LAUNCHER )
    set(CMAKE_CROSSCOMPILING_EMULATOR ${CMAKE_TEST_LAUNCHER})
  elseif(DEFINED ENV{CMAKE_TEST_LAUNCHER})
    set(CMAKE_CROSSCOMPILING_EMULATOR $ENV{CMAKE_TEST_LAUNCHER})
  endif()
endif()
if( CMAKE_CROSSCOMPILING_EMULATOR )
  set( CMAKE_TEST_LAUNCHER ${CMAKE_CROSSCOMPILING_EMULATOR} )
endif()

set(CMAKE_CXX_STANDARD 17)

ecbuild_enable_fortran( REQUIRED NO_MODULE_DIRECTORY )

### Find (optional) dependencies

ecbuild_find_package( NAME fiat REQUIRED )

ecbuild_add_option( FEATURE MPI
                    DESCRIPTION "Support for MPI distributed memory parallelism"
                    REQUIRED_PACKAGES "MPI COMPONENTS Fortran CXX"
                    CONDITION fiat_HAVE_MPI )

ecbuild_add_option( FEATURE OMP
                    DEFAULT ON
                    DESCRIPTION "Support for OpenMP shared memory parallelism"
                    REQUIRED_PACKAGES "OpenMP COMPONENTS Fortran" )

ecbuild_add_option( FEATURE ACC
                    DEFAULT OFF
                    DESCRIPTION "Support for using GPUs with OpenACC"
                    REQUIRED_PACKAGES "OpenACC COMPONENTS Fortran" )

ecbuild_add_option( FEATURE DOUBLE_PRECISION
                    DEFAULT ON
                    DESCRIPTION "Support for Double Precision" )

ecbuild_add_option( FEATURE SINGLE_PRECISION
                    DEFAULT ON
                    DESCRIPTION "Support for Single Precision" )

if( HAVE_SINGLE_PRECISION )
  set( single "single" )
endif()
set( HAVE_dp ${HAVE_DOUBLE_PRECISION} )
set( HAVE_sp ${HAVE_SINGLE_PRECISION} )

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "Use MKL for BLAS and/or FFTW"
                    DEFAULT ON
                    REQUIRED_PACKAGES "MKL QUIET" )

if( NOT HAVE_MKL )
    option( FFTW_ENABLE_MKL OFF )
endif()

ecbuild_add_option( FEATURE CPU
                    DEFAULT ON
                    DESCRIPTION "Compile CPU version of ectrans"
                   )

if( HAVE_CPU )
  ecbuild_find_package( NAME FFTW REQUIRED COMPONENTS double ${single} )
endif()

ecbuild_add_option( FEATURE TRANSI
                    DEFAULT ON
                    DESCRIPTION "Compile TransI C-interface to trans"
                    CONDITION HAVE_DOUBLE_PRECISION AND HAVE_CPU )

# Search for available GPU runtimes, searching for CUDA first and, if not found,
# attempt to find HIP
if( ECTRANS_ENABLE_GPU OR (NOT DEFINED ECTRANS_ENABLE_GPU AND ENABLE_GPU))
  set(HAVE_CUDA 0)
  set(HAVE_HIP 0)
  ectrans_find_cuda() # sets "HAVE_CUDA"
  if( NOT HAVE_CUDA )
    ectrans_find_hip() # sets "HAVE_HIP"
  endif()
endif()

ecbuild_add_option( FEATURE GPU
                    DEFAULT OFF
                    DESCRIPTION "Compile GPU version of ectrans (Requires OpenACC or sufficient OpenMP offloading support)"
                    CONDITION (HAVE_HIP OR HAVE_CUDA) AND (HAVE_ACC OR HAVE_OMP) )

# Check CPU or GPU is enabled, and if not, abort
if( (NOT HAVE_CPU) AND (NOT HAVE_GPU) )
  ecbuild_critical("Please enable one or both of the CPU and GPU features")
endif()

if( HAVE_GPU )
  if( HAVE_ACC )
    set( GPU_OFFLOAD "ACC" )
  elseif( HAVE_OMP )
    set( GPU_OFFLOAD "OMP" )
  else()
    ecbuild_error("Could not enable GPU as OMP or ACC were not enabled")
  endif()
endif()

ecbuild_add_option( FEATURE CUTLASS
                    DEFAULT OFF
                    CONDITION HAVE_GPU AND HAVE_CUDA AND CMAKE_Fortran_COMPILER_ID MATCHES "NVHPC"
                    DESCRIPTION "Support for Cutlass BLAS operations"
                    REQUIRED_PACKAGES "NvidiaCutlass VERSION 2.11" )

# following also needs cuda arch sm80 to be effective
ecbuild_add_option( FEATURE CUTLASS_3XTF32
                    DEFAULT ON
                    CONDITION HAVE_SINGLE_PRECISION AND HAVE_CUTLASS
                    DESCRIPTION "Support for 3xTF32 with Cutlass (>= 2.8) and CUDA_ARCHITECTURES >= 80" )

ecbuild_add_option( FEATURE GPU_AWARE_MPI
                    DEFAULT ON
                    CONDITION HAVE_GPU
                    REQUIRED_PACKAGES "MPI COMPONENTS CXX Fortran"
                    DESCRIPTION "Enable CUDA-aware MPI" )

ecbuild_add_option( FEATURE GPU_GRAPHS_GEMM
                    DEFAULT ON
                    CONDITION HAVE_GPU
                    DESCRIPTION "Enable graph-based optimisation of Legendre transform GEMM kernel" )

ecbuild_add_option( FEATURE GPU_GRAPHS_FFT
                    DEFAULT ON
                    CONDITION HAVE_GPU
                    DESCRIPTION "Enable graph-based optimisation of FFT kernels" )

if( BUILD_SHARED_LIBS )
  set( GPU_STATIC_DEFAULT OFF )
else()
  set( GPU_STATIC_DEFAULT ON )
endif()
ecbuild_add_option( FEATURE GPU_STATIC
                    DEFAULT ${GPU_STATIC_DEFAULT}
                    DESCRIPTION "Compile GPU library as static library")

ecbuild_add_option( FEATURE ETRANS
                    DEFAULT OFF
                    DESCRIPTION "Include Limited-Area-Model Transforms" )

ecbuild_add_option( FEATURE ECTRANS4PY
                    DEFAULT OFF
		    CONDITION HAVE_ETRANS AND HAVE_DOUBLE_PRECISION
                    DESCRIPTION "Compile ectrans4py interface routines for python binding w/ ctypesForFortran" )


ectrans_find_lapack()

### Add sources
include( ectrans_compile_options )
add_subdirectory( src )

### Add tests
if( HAVE_TESTS )
  add_subdirectory( tests )
endif()

### Export
if( BUILD_SHARED_LIBS )
  set( PACKAGE_REQUIRES_PRIVATE_DEPENDENCIES 0 )
else()
  set( PACKAGE_REQUIRES_PRIVATE_DEPENDENCIES 1 )
endif()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== src/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

add_subdirectory( trans )
add_subdirectory( programs )
if( HAVE_TRANSI )
  add_subdirectory(transi)
endif()
add_subdirectory(etrans)
if(HAVE_ECTRANS4PY)
  add_subdirectory(ectrans4py)
endif()

=== tests/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

# --------------------------------------------------------------------------------------------------
# Add a test for installation of ecTrans
# --------------------------------------------------------------------------------------------------

configure_file( test-install.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test-install.sh @ONLY )

unset( _test_args )
if( CMAKE_TOOLCHAIN_FILE )
  list( APPEND _test_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}" )
endif()
foreach( lang C CXX Fortran )
  if( CMAKE_${lang}_COMPILER )
    list( APPEND _test_args "-DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER}" )
  endif()
endforeach()
foreach( lang C CXX Fortran )
  if( CMAKE_${lang}_FLAGS )
    list( APPEND _test_args "-DCMAKE_${lang}_FLAGS=${CMAKE_${lang}_FLAGS}" )
  endif()
endforeach()
if( CMAKE_EXE_LINKER_FLAGS )
  list( APPEND _test_args "-DCMAKE_EXE_LINKER_FLAGS=${CMAKE_EXE_LINKER_FLAGS}" )
endif()
if( NOT HAVE_DOUBLE_PRECISION )
  list( APPEND _test_args "-DCOMPONENTS=single" )
endif()

add_test( NAME ectrans_test_install
          COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test-install.sh ${_test_args} )

# --------------------------------------------------------------------------------------------------
# Add a test for SETUP_TRANS0
# --------------------------------------------------------------------------------------------------

ecbuild_add_executable(
  TARGET  ectrans_test_setup_trans0
  SOURCES trans/test_setup_trans0.F90
  LIBS    ectrans_common
  LINKER_LANGUAGE Fortran
  NOINSTALL)
set( ntasks 0 )
if( HAVE_MPI )
  list( APPEND ntasks 1 2 )
endif()
foreach( mpi ${ntasks} )
    ecbuild_add_test( TARGET ectrans_test_setup_trans0_mpi${mpi}
        COMMAND ectrans_test_setup_trans0
        MPI ${mpi}
    )
endforeach()

# --------------------------------------------------------------------------------------------------
# Add a test for tangent-linear/adjoint correspondence of INV_TRANS and DIR_TRANS combined (CPU
# version only)
# --------------------------------------------------------------------------------------------------

if( HAVE_CPU )
  set( precisions "" )
  if( HAVE_DOUBLE_PRECISION )
    list( APPEND precisions "dp" )
  endif()
  if( HAVE_SINGLE_PRECISION )
    list( APPEND precisions "sp" )
  endif()

  set( ntasks 0 )
  if( HAVE_MPI )
    list( APPEND ntasks 1 2 )
  endif()

  foreach( precision ${precisions} )
    foreach( mpi ${ntasks} )
      set( test_name ectrans_test_adjoint_mpi${mpi}_${precision} )
      ecbuild_add_test(TARGET ${test_name}
        SOURCES trans/test_adjoint.F90
        LIBS trans_${precision} parkind_${precision}
        LINKER_LANGUAGE Fortran
        MPI ${mpi}
      )
      if( TEST ${test_name} AND HAVE_OMP )
        target_link_libraries( ${test_name} OpenMP::OpenMP_Fortran )
      endif()
    endforeach()
  endforeach()
endif()

# --------------------------------------------------------------------------------------------------
# Add tests for tangent-linear/adjoint correspondence of INV_TRANS and DIR_TRANS
# --------------------------------------------------------------------------------------------------

set( platforms )
if( HAVE_CPU )
  list( APPEND platforms cpu )
endif()
if( HAVE_GPU )
  list( APPEND platforms gpu )
endif()

foreach( platform ${platforms} )
  
  if( "${platform}" MATCHES "cpu" )
    set( platform_tag "" )
  endif()
  if( "${platform}" MATCHES "gpu" )
    set( platform_tag "_gpu" )
  endif()
  
  if( HAVE_DOUBLE_PRECISION )
    set( trans trans${platform_tag}_dp )
    set( parkind parkind_dp )
  else()
    set( trans trans${platform_tag}_sp )
    set( parkind parkind_sp )
  endif()

  set( ntasks 0 )
  if( HAVE_MPI )
    list( APPEND ntasks 1 2 )
  endif()

  foreach( mpi ${ntasks} )
    ecbuild_add_test(TARGET ectrans_test_dirtrans_adjoint_${platform}_mpi${mpi}
      SOURCES trans/test_dirtrans_adjoint.F90
      LIBS ${trans} ${parkind}
      LINKER_LANGUAGE Fortran
      MPI ${mpi}
      OMP 1
    )
    if( TEST ectrans_test_dirtrans_adjoint_${platform}_mpi${mpi} AND HAVE_OMP )
      target_link_libraries( ectrans_test_dirtrans_adjoint_${platform}_mpi${mpi} OpenMP::OpenMP_Fortran )
    endif()
    set_tests_properties(ectrans_test_dirtrans_adjoint_${platform}_mpi${mpi} PROPERTIES LABELS "${platform};Fortran")

    ecbuild_add_test(TARGET ectrans_test_invtrans_adjoint_${platform}_mpi${mpi}
      SOURCES trans/test_invtrans_adjoint.F90
      LIBS ${trans} ${parkind}
      LINKER_LANGUAGE Fortran
      MPI ${mpi}
      OMP 1
    )
    if( TEST ectrans_test_invtrans_adjoint_${platform}_mpi${mpi} AND HAVE_OMP )
      target_link_libraries( ectrans_test_invtrans_adjoint_${platform}_mpi${mpi} OpenMP::OpenMP_Fortran )
    endif()
    set_tests_properties(ectrans_test_invtrans_adjoint_${platform}_mpi${mpi} PROPERTIES LABELS "${platform};Fortran")
    
  endforeach() # mpi comm size

endforeach() # platform

# --------------------------------------------------------------------------------------------------
# Add a test for tangent-linear/adjoint correspondence of GPNORM_TRANSTL/AD (CPU version only)
# --------------------------------------------------------------------------------------------------

if( HAVE_CPU )
  set( precisions "" )
  if( HAVE_DOUBLE_PRECISION )
    list( APPEND precisions "dp" )
  endif()
  if( HAVE_SINGLE_PRECISION )
    list( APPEND precisions "sp" )
  endif()

  set( ntasks 0 )
  if( HAVE_MPI )
    list( APPEND ntasks 1 2 )
  endif()

  foreach( precision ${precisions} )
    foreach( mpi ${ntasks} )
      set( test_name ectrans_test_gpnorm_trans_adjoint_mpi${mpi}_${precision} )
      ecbuild_add_test(TARGET ${test_name}
        SOURCES trans/test_gpnorm_adjoint.F90
        LIBS trans_${precision} parkind_${precision}
        LINKER_LANGUAGE Fortran
        MPI ${mpi}
      )
      if( TEST ${test_name} AND HAVE_OMP )
        target_link_libraries( ${test_name} OpenMP::OpenMP_Fortran )
      endif()
    endforeach()
  endforeach()
endif()

# --------------------------------------------------------------------------------------------------
# Add tests for common call patterns of ecTrans, using the benchmark program
# This tests CPU and/or GPU versions, depending on which are enabled
# --------------------------------------------------------------------------------------------------

macro(ectrans_set_test_properties target)
  if( "${target}" MATCHES "gpu" )
    set_tests_properties(${target} PROPERTIES LABELS "gpu;Fortran")
  endif()
  set_tests_properties( ${target} PROPERTIES FIXTURES_SETUP checksum_tests )
endmacro()

# Determine which benchmarks are available
set( benchmarks "" )
if( TARGET ectrans-benchmark-cpu-dp )
  list( APPEND benchmarks ectrans-benchmark-cpu-dp )
endif()
if( TARGET ectrans-benchmark-cpu-sp )
  list( APPEND benchmarks ectrans-benchmark-cpu-sp )
endif()
if( TARGET ectrans-benchmark-gpu-dp )
  list( APPEND benchmarks ectrans-benchmark-gpu-dp )
endif()
if( TARGET ectrans-benchmark-gpu-sp )
  list( APPEND benchmarks ectrans-benchmark-gpu-sp )
endif()

foreach( benchmark ${benchmarks} )
  # Establish which task/thread parameters to test
  set( ntasks 0 )
  set( nthreads 1 )
  if( HAVE_MPI )
    list( APPEND ntasks 1 2 )
  endif()
  if( ${benchmark} MATCHES "cpu" )
    if( HAVE_OMP )
      list( APPEND nthreads 8 )
    endif()
  endif()

  if( NOT TEST compare_checksums AND (HAVE_MPI OR HAVE_OMP) )
    configure_file( compare_checksums.py ${CMAKE_CURRENT_BINARY_DIR}/compare_checksums.py @ONLY )
    list( JOIN ntasks "," ntasks_joined )
    list( JOIN nthreads "," nthreads_joined )
    ecbuild_add_test( TARGET compare_checksums
      COMMAND "${CMAKE_CURRENT_BINARY_DIR}/compare_checksums.py"
      ARGS "." ${ntasks_joined} ${nthreads_joined}
    )
    set_tests_properties( compare_checksums PROPERTIES FIXTURES_REQUIRED checksum_tests )
  endif()

  # Add test for each parameter combination
  foreach( mpi ${ntasks} )
    foreach( omp ${nthreads} )
      # TCO47 truncation
      set( t 47 )
      set( grid O48 )

      # Base arguments -> 2 iterations, memory consumption/pinning information, spectral norms, and
      # verbose output
      set( base_args --niter 2 --meminfo --norms -v )

      foreach( callmode 1 2 )
        set (base_title "${benchmark}_T${t}_${grid}_mpi${mpi}_omp${omp}_callmode${callmode}")
        # Check it works with 0 3D scalar fields
        ecbuild_add_test( TARGET ${base_title}_nfld0
            COMMAND ${benchmark}
            ARGS --truncation ${t} --grid ${grid} --nfld 0 --check 100 --callmode ${callmode} --dump-checksums ${base_title}_nfld0 ${base_args}
            MPI ${mpi}
            OMP ${omp}
        )
        ectrans_set_test_properties( ${base_title}_nfld0 )

        # Check it works with 10 3D scalar fields and 20 levels
        ecbuild_add_test( TARGET ${base_title}_nfld10_nlev20
            COMMAND ${benchmark}
            ARGS --truncation ${t} --grid ${grid} --nfld 10 --nlev 20 --check 100 --callmode ${callmode} --dump-checksums ${base_title}_nfld10_nlev20 ${base_args}
            MPI ${mpi}
            OMP ${omp}
        )
        ectrans_set_test_properties( ${base_title}_nfld10_nlev20 )

        # Check it works with 10 3D scalar fields, 20 levels, and derivatives
        ecbuild_add_test( TARGET ${base_title}_nfld10_nlev20_derivatives
            COMMAND ${benchmark}
            ARGS --truncation ${t} --grid ${grid} --nfld 10 --nlev 20 --scders --uvders --check 100 --callmode ${callmode} --dump-checksums ${base_title}_nfld10_nlev20_derivatives ${base_args}
            MPI ${mpi}
            OMP ${omp}
        )
        ectrans_set_test_properties( ${base_title}_nfld10_nlev20_derivatives )

        # Check it works with 10 3D scalar fields, 20 levels, and vordiv in grid point space
        ecbuild_add_test( TARGET ${base_title}_nfld10_nlev20_vordiv
            COMMAND ${benchmark}
            ARGS --truncation ${t} --grid ${grid} --nfld 10 --nlev 20 --vordiv --check 100  --callmode ${callmode} --dump-checksums ${base_title}_nfld10_nlev20_vordiv ${base_args}
            MPI ${mpi}
            OMP ${omp}
        )
        ectrans_set_test_properties( ${base_title}_nfld10_nlev20_vordiv )

        # Check it works with 10 3D scalar fields, 20 levels, and NPROMA=16
        ecbuild_add_test( TARGET ${base_title}_nfld10_nlev20_nproma16
            COMMAND ${benchmark}
            ARGS --truncation ${t} --grid ${grid} --nfld 10 --nlev 20 --nproma 16 --check 100 --callmode ${callmode} --dump-checksums ${base_title}_nfld10_nlev20_vordiv_uvders ${base_args}
            MPI ${mpi}
            OMP ${omp}
        )
        ectrans_set_test_properties( ${base_title}_nfld10_nlev20_nproma16 )

        # Check it works with 10 3D scalar fields, 20 levels, and NPROMATR=20 (feature only works for CPU)
        if( ${benchmark} MATCHES "cpu" AND ${callmode} MATCHES "1" )
          ecbuild_add_test( TARGET ${base_title}_nfld10_nlev20_npromatr20
              COMMAND ${benchmark}
              ARGS --truncation ${t} --grid ${grid} --nfld 10 --nlev 20 --npromatr 20 --check 100 --callmode ${callmode} --dump-checksums ${base_title}_nfld10_nlev20_vordiv_uvders ${base_args}
              MPI ${mpi}
              OMP ${omp}
          )
          ectrans_set_test_properties( ${base_title}_nfld10_nlev20_npromatr20 )
        endif()

        if( ${benchmark} MATCHES "cpu" )
          # Check it works with 10 3D scalar fields, 20 levels, and the fast Legendre tranform (CPU only)
          # TODO: Find out why the FLT gives so much higher errors
          ecbuild_add_test( TARGET ${base_title}_nfld10_nlev20_flt
              COMMAND ${benchmark}

=== src/ectrans4py/CMakeLists.txt ===
# (using CMAKE_CURRENT_SOURCE_DIR is necessary because sources are in a different directory than the target library (trans_${prec}))
ecbuild_list_add_pattern(
    LIST ectrans4py_src
    GLOB ${CMAKE_CURRENT_SOURCE_DIR}/*.F90
    QUIET
)

# Add ectrans4py library
ecbuild_add_library(
      TARGET           ectrans4py_dp
      LINKER_LANGUAGE  Fortran
      SOURCES          ${ectrans4py_src}
      PUBLIC_LIBS      fiat trans_dp parkind_dp etrans_dp
)

=== src/etrans/CMakeLists.txt ===


# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

function(generate_file)
  set (options)
  set (oneValueArgs INPUT OUTPUT BACKEND)
  set (multiValueArgs)
  cmake_parse_arguments(_PAR "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  set(output  ${_PAR_OUTPUT})
  set(input   ${_PAR_INPUT})
  set(backend ${_PAR_BACKEND})
  set(sed_rules ${PROJECT_SOURCE_DIR}/src/etrans/sedrenames.txt)

  set( JPRB_dp JPRD )
  set( jprb_dp jprd )
  set( JPRB_sp JPRM )
  set( jprb_sp jprm )
  set( JPRB_gpu_dp JPRD )
  set( jprb_gpu_dp jprd )
  set( JPRB_gpu_sp JPRM )
  set( jprb_gpu_sp jprm )

  add_custom_command(
    OUTPUT  ${output}
    COMMAND  cat ${sed_rules} |
             sed -e "s/VARIANTDESIGNATOR/${backend}/g" |
             sed -e "s/TYPEDESIGNATOR_UPPER/${JPRB_${backend}}/g" |
             sed -e "s/TYPEDESIGNATOR_LOWER/${jprb_${backend}}/g" |
             sed -rf - ${input} > ${output}
    DEPENDS  ${input} ${sed_rules}
    COMMENT "Generating ${output}"
    VERBATIM
  )
endfunction(generate_file)


function(generate_backend_includes)
  set (options)
  set (oneValueArgs BACKEND TARGET DESTINATION INCLUDE_DIRECTORY)
  set (multiValueArgs)
  cmake_parse_arguments(_PAR "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  set(destination ${_PAR_DESTINATION} )
  set(backend     ${_PAR_BACKEND})

  file(MAKE_DIRECTORY ${destination})
  file(MAKE_DIRECTORY ${destination}/etrans_${backend})

  ecbuild_list_add_pattern( LIST absolute_files GLOB etrans/*.h SOURCE_DIR ${_PAR_INCLUDE_DIRECTORY} QUIET )
  set( files )
  foreach(file_i ${absolute_files})
    file(RELATIVE_PATH file_i ${_PAR_INCLUDE_DIRECTORY} ${file_i})
    list(APPEND files ${file_i})
  endforeach()
  set( outfiles )
  foreach(file_i ${files})
    get_filename_component(outfile_name    ${file_i} NAME)
    get_filename_component(outfile_name_we ${file_i} NAME_WE)
    get_filename_component(outfile_ext     ${file_i} EXT)
    get_filename_component(outfile_dir     ${file_i} DIRECTORY)
    if (${file_i} IN_LIST ectrans_common_includes)
      configure_file(${_PAR_INCLUDE_DIRECTORY}/${file_i} ${destination}/${outfile_name})
    else()
      set(outfile "${destination}/${outfile_name_we}_${backend}${outfile_ext}")
      ecbuild_debug("Generate ${outfile}")
      generate_file(BACKEND ${backend} INPUT ${_PAR_INCLUDE_DIRECTORY}/${file_i} OUTPUT ${outfile})
      list(APPEND outfiles ${outfile})
      string(TOUPPER ${outfile_name_we} OUTFILE_NAME_WE )
      ecbuild_debug("Generate ${destination}/trans_${backend}/${outfile_name}")
      file(WRITE  ${destination}/etrans_${backend}/${outfile_name} "! Automatically generated interface header for backward compatibility of generic symbols !\n")
      file(APPEND ${destination}/etrans_${backend}/${outfile_name} "#if defined(${outfile_name_we})\n")
      file(APPEND ${destination}/etrans_${backend}/${outfile_name} "#undef ${outfile_name_we}\n")
      file(APPEND ${destination}/etrans_${backend}/${outfile_name} "#endif\n")
      file(APPEND ${destination}/etrans_${backend}/${outfile_name} "#if defined(${OUTFILE_NAME_WE})\n")
      file(APPEND ${destination}/etrans_${backend}/${outfile_name} "#undef ${OUTFILE_NAME_WE}\n")
      file(APPEND ${destination}/etrans_${backend}/${outfile_name} "#endif\n")
      file(APPEND ${destination}/etrans_${backend}/${outfile_name} "#include \"${outfile_name_we}_${backend}${outfile_ext}\"\n")
      file(APPEND ${destination}/etrans_${backend}/${outfile_name} "#define ${outfile_name_we} ${OUTFILE_NAME_WE}_${backend}\n")
      file(APPEND ${destination}/etrans_${backend}/${outfile_name} "#define ${OUTFILE_NAME_WE} ${OUTFILE_NAME_WE}_${backend}\n")
    endif()
  endforeach(file_i)

  add_custom_target(${_PAR_TARGET}_generate DEPENDS ${outfiles})
  ecbuild_add_library(TARGET ${_PAR_TARGET} TYPE INTERFACE)
  add_dependencies(${_PAR_TARGET} ${_PAR_TARGET}_generate)
  target_include_directories(${_PAR_TARGET} INTERFACE $<BUILD_INTERFACE:${destination}>)
endfunction(generate_backend_includes)





# TODO: move precision-independent files to common
#add_subdirectory( common )

if( HAVE_CPU)
  add_subdirectory( cpu )
endif()

# placeholder
#if( HAVE_GPU )
#  add_subdirectory( gpu )
#endif()


if (FALSE)
# original cmake file for etrans; keeping it for reference, but should be cleaned later
message(FATAL_ERROR "Hold it right there!")

# build list of sources to add to trans library 
# (using CMAKE_CURRENT_SOURCE_DIR is necessary because sources are in a different directory than the target library (trans_${prec})
ecbuild_list_add_pattern( LIST etrans_src
					  GLOB
							${CMAKE_CURRENT_SOURCE_DIR}/biper/internal/*
							${CMAKE_CURRENT_SOURCE_DIR}/biper/external/*
							${CMAKE_CURRENT_SOURCE_DIR}/etrans/internal/*
							${CMAKE_CURRENT_SOURCE_DIR}/etrans/external/*
					  QUIET
					)

# dummies to be able to loop over precisions
set( HAVE_dp ${HAVE_DOUBLE_PRECISION} )
set( HAVE_sp ${HAVE_SINGLE_PRECISION} )

# loop over precisions
foreach( prec sp dp )
  if( HAVE_${prec} )
	# add sources
	target_sources(trans_${prec} PRIVATE ${etrans_src})
	# add include directories
	target_include_directories(trans_${prec}
	    PUBLIC
			$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/biper/include>
			$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/etrans/include>
    )
  endif()
endforeach()

# install headers
file( GLOB etrans_interface biper/include/* etrans/include/*)
install(
  FILES        ${etrans_interface}
  DESTINATION  include/ectrans
)

endif()

=== src/programs/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

#foreach( program ectrans-benchmark ectrans-benchmark-ifs )
foreach( program ectrans-benchmark )

  list( APPEND util_src
    util/ectrans_memory.F90
    util/ectrans_memory.c
  )

  if ( HAVE_CPU )
    foreach( prec dp sp )
      if( HAVE_${prec} )
        ecbuild_add_executable( TARGET  ${program}-cpu-${prec}
                                SOURCES ${program}.F90 ${util_src}
                                LINKER_LANGUAGE Fortran
                                LIBS
                                  fiat
                                  parkind_${prec}
                                  trans_${prec}
                                DEFINITIONS
                                  VERSION="cpu"
        )
        ectrans_target_fortran_module_directory(TARGET ${program}-cpu-${prec} MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/module/${program}-cpu-${prec} )
      endif()
    endforeach( prec)
  endif()

  if( HAVE_GPU )
    list( APPEND util_PRIVATE_DEFINITIONS
      $<${HAVE_CUDA}:CUDA>
      $<${HAVE_HIP}:HIP>
    )
    list( APPEND util_PRIVATE_LIBRARIES
      $<${HAVE_CUDA}:CUDA::cudart>
      $<${HAVE_HIP}:hip::host>
    )
    foreach( prec dp sp )
      if( HAVE_${prec} )
        ecbuild_add_executable( TARGET  ${program}-gpu-${prec}
                                SOURCES ${program}.F90 ${util_src}
                                LINKER_LANGUAGE Fortran
                                LIBS
                                  fiat
                                  parkind_${prec}
                                  trans_gpu_${prec}
                                  $<${HAVE_ACC}:OpenACC::OpenACC_Fortran>
                                  $<${HAVE_OMP}:OpenMP::OpenMP_Fortran>
                                  ${util_PRIVATE_LIBRARIES}
                                DEFINITIONS
                                  VERSION="gpu"
                                  ${util_PRIVATE_DEFINITIONS}
        )
        ectrans_target_fortran_module_directory(TARGET ${program}-gpu-${prec} MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/module/${program}-gpu-${prec} )
      endif()
    endforeach( prec )
  endif( HAVE_GPU )
endforeach( program )

if( HAVE_ETRANS )
  foreach( prec sp dp )
    if( HAVE_${prec} )
      ecbuild_add_executable( TARGET  ectrans-lam-benchmark-cpu-${prec}
                              SOURCES ectrans-lam-benchmark.F90
                              LINKER_LANGUAGE Fortran
                              LIBS
                                fiat
                                parkind_${prec}
                                trans_${prec}
                                etrans_${prec}
                                $<${HAVE_OMP}:OpenMP::OpenMP_Fortran>
                            )
    endif()
  endforeach()
endif()

# ectrans information tool

get_property( langs GLOBAL PROPERTY ENABLED_LANGUAGES )

foreach( lang ${langs} )
  set( EC_${lang}_FLAGS "${CMAKE_${lang}_FLAGS} ${CMAKE_${lang}_FLAGS_${CMAKE_BUILD_TYPE_CAPS}}" )
endforeach()

configure_file( ectrans.in ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/ectrans @ONLY )

file(COPY ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/ectrans
  DESTINATION ${CMAKE_BINARY_DIR}/bin
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ
  GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

install( FILES
  ${CMAKE_BINARY_DIR}/bin/ectrans
  DESTINATION
  ${INSTALL_BIN_DIR}
  PERMISSIONS
  OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== src/trans/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

function(generate_file)
  set (options)
  set (oneValueArgs INPUT OUTPUT BACKEND)
  set (multiValueArgs)
  cmake_parse_arguments(_PAR "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  set(output  ${_PAR_OUTPUT})
  set(input   ${_PAR_INPUT})
  set(backend ${_PAR_BACKEND})
  set(sed_rules ${PROJECT_SOURCE_DIR}/src/trans/sedrenames.txt)

  set( JPRB_dp JPRD )
  set( jprb_dp jprd )
  set( JPRB_sp JPRM )
  set( jprb_sp jprm )
  set( JPRB_gpu_dp JPRD )
  set( jprb_gpu_dp jprd )
  set( JPRB_gpu_sp JPRM )
  set( jprb_gpu_sp jprm )

  add_custom_command(
    OUTPUT  ${output}
    COMMAND  cat ${sed_rules} |
             sed -e "s/VARIANTDESIGNATOR/${backend}/g" |
             sed -e "s/TYPEDESIGNATOR_UPPER/${JPRB_${backend}}/g" |
             sed -e "s/TYPEDESIGNATOR_LOWER/${jprb_${backend}}/g" |
             sed -rf - ${input} > ${output}
    DEPENDS  ${input} ${sed_rules}
    COMMENT "Generating ${output}"
    VERBATIM
  )
endfunction(generate_file)


function(generate_backend_includes)
  set (options)
  set (oneValueArgs BACKEND TARGET DESTINATION INCLUDE_DIRECTORY)
  set (multiValueArgs)
  cmake_parse_arguments(_PAR "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})

  set(destination ${_PAR_DESTINATION} )
  set(backend     ${_PAR_BACKEND})

  file(MAKE_DIRECTORY ${destination})
  file(MAKE_DIRECTORY ${destination}/trans_${backend})

  ecbuild_list_add_pattern( LIST absolute_files GLOB ectrans/*.h SOURCE_DIR ${_PAR_INCLUDE_DIRECTORY} QUIET )
  set( files )
  foreach(file_i ${absolute_files})
    file(RELATIVE_PATH file_i ${_PAR_INCLUDE_DIRECTORY} ${file_i})
    list(APPEND files ${file_i})
  endforeach()
  set( outfiles )
  foreach(file_i ${files})
    get_filename_component(outfile_name    ${file_i} NAME)
    get_filename_component(outfile_name_we ${file_i} NAME_WE)
    get_filename_component(outfile_ext     ${file_i} EXT)
    get_filename_component(outfile_dir     ${file_i} DIRECTORY)
    if (${file_i} IN_LIST ectrans_common_includes)
      configure_file(${_PAR_INCLUDE_DIRECTORY}/${file_i} ${destination}/${outfile_name})
    else()
      set(outfile "${destination}/${outfile_name_we}_${backend}${outfile_ext}")
      ecbuild_debug("Generate ${outfile}")
      generate_file(BACKEND ${backend} INPUT ${_PAR_INCLUDE_DIRECTORY}/${file_i} OUTPUT ${outfile})
      list(APPEND outfiles ${outfile})
      string(TOUPPER ${outfile_name_we} OUTFILE_NAME_WE )
      ecbuild_debug("Generate ${destination}/trans_${backend}/${outfile_name}")
      file(WRITE  ${destination}/trans_${backend}/${outfile_name} "! Automatically generated interface header for backward compatibility of generic symbols !\n")
      file(APPEND ${destination}/trans_${backend}/${outfile_name} "#if defined(${outfile_name_we})\n")
      file(APPEND ${destination}/trans_${backend}/${outfile_name} "#undef ${outfile_name_we}\n")
      file(APPEND ${destination}/trans_${backend}/${outfile_name} "#endif\n")
      file(APPEND ${destination}/trans_${backend}/${outfile_name} "#if defined(${OUTFILE_NAME_WE})\n")
      file(APPEND ${destination}/trans_${backend}/${outfile_name} "#undef ${OUTFILE_NAME_WE}\n")
      file(APPEND ${destination}/trans_${backend}/${outfile_name} "#endif\n")
      file(APPEND ${destination}/trans_${backend}/${outfile_name} "#include \"${outfile_name_we}_${backend}${outfile_ext}\"\n")
      file(APPEND ${destination}/trans_${backend}/${outfile_name} "#define ${outfile_name_we} ${OUTFILE_NAME_WE}_${backend}\n")
      file(APPEND ${destination}/trans_${backend}/${outfile_name} "#define ${OUTFILE_NAME_WE} ${OUTFILE_NAME_WE}_${backend}\n")
    endif()
  endforeach(file_i)

  add_custom_target(${_PAR_TARGET}_generate DEPENDS ${outfiles})
  ecbuild_add_library(TARGET ${_PAR_TARGET} TYPE INTERFACE)
  add_dependencies(${_PAR_TARGET} ${_PAR_TARGET}_generate)
  target_include_directories(${_PAR_TARGET} INTERFACE $<BUILD_INTERFACE:${destination}>)
endfunction(generate_backend_includes)






add_subdirectory( common )

if( HAVE_CPU)
  add_subdirectory( cpu )
endif()
if( HAVE_GPU )
  add_subdirectory( gpu )
endif()

=== src/transi/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

if( NOT ectrans_VERSION_PATCH )
  set( ectrans_VERSION_PATCH 0 )
endif()

configure_file( version.c.in  version.c )

ecbuild_add_library( TARGET transi_dp
  SOURCES             transi_module.F90
                      transi.h
                      transi.c
                      version.h
                      ${CMAKE_CURRENT_BINARY_DIR}/version.c
  HEADER_DESTINATION  include/ectrans
  PUBLIC_INCLUDES     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
                      $<INSTALL_INTERFACE:include>
  PRIVATE_LIBS        trans_dp
                      $<${ectrans_HAVE_ETRANS}:etrans_dp>
  PRIVATE_DEFINITIONS ECTRANS_HAVE_MPI=${ectrans_HAVE_MPI}
                      ECTRANS_HAVE_ETRANS=${ectrans_HAVE_ETRANS}
)
ectrans_target_fortran_module_directory( TARGET transi_dp
  MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module/trans_dp
)

if( HAVE_GPU )
  ecbuild_add_library( TARGET transi_gpu_dp
    SOURCES             transi_module.F90
                        transi.h
                        transi.c
                        version.h
                        ${CMAKE_CURRENT_BINARY_DIR}/version.c
    HEADER_DESTINATION  include/ectrans
    PUBLIC_INCLUDES     $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
                        $<INSTALL_INTERFACE:include>
    PRIVATE_LIBS        trans_gpu_dp
    PRIVATE_DEFINITIONS ECTRANS_HAVE_MPI=${ectrans_HAVE_MPI}
                        ECTRANS_GPU_VERSION
                        ECTRANS_HAVE_ETRANS=0
  )
  if( HAVE_ACC AND CMAKE_Fortran_COMPILER_ID MATCHES NVHPC )
    # Propagate flags as link options for downstream targets. Only required for NVHPC
    target_link_options( transi_gpu_dp INTERFACE
      $<$<LINK_LANGUAGE:Fortran>:SHELL:${OpenACC_Fortran_FLAGS}>
      $<$<LINK_LANG_AND_ID:C,NVHPC>:SHELL:${OpenACC_Fortran_FLAGS}>
      $<$<LINK_LANG_AND_ID:CXX,NVHPC>:SHELL:${OpenACC_Fortran_FLAGS}> )
  endif()

  ectrans_target_fortran_module_directory( TARGET transi_gpu_dp
    MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module/trans_gpu_dp
  )
endif()

set( transi_includes transi.h version.h )
install(
  FILES        ${transi_includes}
  DESTINATION  include/ectrans
)

=== tests/test_install/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )
project( ectrans_test_install VERSION 0.0.0 LANGUAGES Fortran )

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

if( COMPONENTS )
  find_package( ectrans REQUIRED COMPONENTS ${COMPONENTS} )
else()
  find_package( ectrans REQUIRED )
endif()

if( TARGET trans_dp )
  add_executable( main_dp main.F90 )
  target_link_libraries( main_dp trans_dp )
endif()

if( TARGET trans_sp )
  add_executable( main_sp main.F90 )
  target_link_libraries( main_sp trans_sp )
endif()

if( TARGET transi_dp )
  enable_language( C )
  add_executable( transi_sptogp transi_sptogp.c )
  target_link_libraries( transi_sptogp transi_dp )

  add_executable( transi_gptosp transi_gptosp.c )
  target_link_libraries( transi_gptosp transi_dp )

endif()

=== src/etrans/cpu/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

## Apply workarounds for some known compilers
## see trans/ for example

function(generate_backend_sources)
  set (options)
  set (oneValueArgs BACKEND DESTINATION OUTPUT)
  set (multiValueArgs)

  cmake_parse_arguments(_PAR "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
  set(backend ${_PAR_BACKEND})
  set(destination ${_PAR_DESTINATION})
  file(MAKE_DIRECTORY ${destination}/biper/internal)
  file(MAKE_DIRECTORY ${destination}/biper/external)
  file(MAKE_DIRECTORY ${destination}/internal)
  file(MAKE_DIRECTORY ${destination}/external)

  ecbuild_list_add_pattern( LIST files
    GLOB
    internal/*.F90
    external/*.F90
    biper/internal/*.F90
          biper/external/*.F90
    QUIET
  )

  set(outfiles)
  foreach(file_i ${files})
    get_filename_component(outfile_name    ${file_i} NAME)
    get_filename_component(outfile_name_we ${file_i} NAME_WE)
    get_filename_component(outfile_ext     ${file_i} EXT)
    get_filename_component(outfile_dir     ${file_i} DIRECTORY)
    set(outfile "${destination}/${file_i}")
    ecbuild_debug("Generate ${outfile}")
    generate_file(BACKEND ${backend} INPUT ${CMAKE_CURRENT_SOURCE_DIR}/${file_i} OUTPUT ${outfile})
    list(APPEND outfiles ${outfile})
  endforeach(file_i)
  set(${_PAR_OUTPUT} ${outfiles} PARENT_SCOPE)
endfunction(generate_backend_sources)

set( BUILD_INTERFACE_INCLUDE_DIR ${CMAKE_BINARY_DIR}/include/ectrans )

function(generate_etrans_dummy_sources)
  set (options)
  set (oneValueArgs BACKEND DESTINATION OUTPUT)
  set (multiValueArgs)

  cmake_parse_arguments(_PAR "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
  set(backend ${_PAR_BACKEND})
  set(destination ${_PAR_DESTINATION})

  file(MAKE_DIRECTORY ${destination}/external)

  # Build list of interface files to generate dummy sources for
  ecbuild_list_add_pattern( LIST include_files
    GLOB etrans/*.h
    SOURCE_DIR ${PROJECT_SOURCE_DIR}/src/etrans/include
    QUIET
  )

  foreach( include_file ${include_files} )
    cmake_path( GET include_file STEM file_stem )
    set(dummy_source "${file_stem}.F90")

    # First generate a dummy source file from the interface that just contains an abort
    file( READ ${include_file} contents )
    string( REPLACE "END INTERFACE" "" contents "${contents}" )
    string( REPLACE "INTERFACE" "" contents "${contents}" )
    string(
      REPLACE "IMPLICIT NONE" "USE ABORT_TRANS_MOD, ONLY: ABORT_TRANS\nIMPLICIT NONE"
      contents "${contents}"
    )
    string(
      REPLACE "END SUBROUTINE"
        "CALL ABORT_TRANS(\"etrans dummy library - you should not be here\")\nEND SUBROUTINE"
      contents "${contents}"
    )
    file( WRITE ${CMAKE_CURRENT_BINARY_DIR}/generated/etrans_dummy/${dummy_source} "${contents}" )

    # Then run the dummy source through the normal backend file generator
    set(outfile "${destination}/${dummy_source}")
    ecbuild_debug("Generate ${outfile}")
    generate_file(BACKEND ${backend} INPUT ${CMAKE_CURRENT_BINARY_DIR}/generated/etrans_dummy/${dummy_source} OUTPUT ${outfile})
    list(APPEND outfiles ${outfile})
  endforeach( include_file )
  set(${_PAR_OUTPUT} ${outfiles} PARENT_SCOPE)
endfunction(generate_etrans_dummy_sources)

foreach( prec dp sp )
  if( HAVE_${prec} )

    generate_backend_includes(BACKEND ${prec} TARGET ectrans_etrans_${prec}_includes DESTINATION ${BUILD_INTERFACE_INCLUDE_DIR} INCLUDE_DIRECTORY ${PROJECT_SOURCE_DIR}/src/etrans/include )

    if( NOT HAVE_ETRANS )
      generate_etrans_dummy_sources(
        BACKEND     ${prec}
        OUTPUT      ectrans_etrans_${prec}_src
        DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/generated/ectrans_etrans_${prec}
      )
    else()
      generate_backend_sources(
        BACKEND     ${prec}
        OUTPUT      ectrans_etrans_${prec}_src
        DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/generated/ectrans_etrans_${prec}
      )
    endif()

    ecbuild_add_library(
      TARGET           ectrans_etrans_${prec}
      LINKER_LANGUAGE  Fortran
      SOURCES          ${ectrans_etrans_${prec}_src}
      PUBLIC_INCLUDES  $<INSTALL_INTERFACE:include/ectrans>
                       $<INSTALL_INTERFACE:include>
                       $<BUILD_INTERFACE:${BUILD_INTERFACE_INCLUDE_DIR}>
      PUBLIC_LIBS      fiat ectrans_common ectrans_${prec}_includes ectrans_${prec} ectrans_etrans_${prec}_includes
    )

    ectrans_target_fortran_module_directory(
      TARGET            ectrans_etrans_${prec}
      MODULE_DIRECTORY  ${CMAKE_BINARY_DIR}/module/ectrans
      INSTALL_DIRECTORY module/ectrans
    )

    if( HAVE_ETRANS )
      set( FFTW_LINK PRIVATE )
      if( LAPACK_LIBRARIES MATCHES "mkl" AND NOT FFTW_LIBRARIES MATCHES "mkl" )
          ecbuild_warn( "Danger: Both MKL and FFTW are linked in ectrans_etrans_${prec}. "
                        "No guarantees on link order can be made for the final executable.")
          set( FFTW_LINK PUBLIC ) # Attempt anyway to give FFTW precedence
      endif()
      ecbuild_debug("target_link_libraries( ectrans_etrans_${prec} ${FFTW_LINK} ${FFTW_LIBRARIES} )")
      target_link_libraries( ectrans_etrans_${prec} ${FFTW_LINK} ${FFTW_LIBRARIES} )
      target_include_directories( ectrans_etrans_${prec} PRIVATE ${FFTW_INCLUDE_DIRS} )
      target_compile_definitions( ectrans_etrans_${prec} PRIVATE WITH_FFTW )
      # daand: lam transforms don't need lapack
      #ecbuild_debug("target_link_libraries( ectrans_etrans_${prec} PRIVATE ${LAPACK_LIBRARIES} )")
      #target_link_libraries( ectrans_${prec} PRIVATE ${LAPACK_LIBRARIES} )

      if( HAVE_OMP )
        ecbuild_debug("target_link_libraries( ectrans_etrans_${prec} PRIVATE OpenMP::OpenMP_Fortran )")
        target_link_libraries( ectrans_etrans_${prec} PRIVATE OpenMP::OpenMP_Fortran )
      endif()
    endif()

    # This interface library is for backward compatibility, and provides the older includes
    ecbuild_add_library( TARGET etrans_${prec} TYPE INTERFACE )
    target_include_directories( etrans_${prec} INTERFACE $<BUILD_INTERFACE:${BUILD_INTERFACE_INCLUDE_DIR}/etrans_${prec}> )
    target_include_directories( etrans_${prec} INTERFACE $<INSTALL_INTERFACE:include/ectrans/etrans_${prec}> )
    target_link_libraries( etrans_${prec} INTERFACE ectrans_etrans_${prec} )
  endif()
endforeach()

## Install trans interface
install( DIRECTORY ${BUILD_INTERFACE_INCLUDE_DIR}/ DESTINATION include/ectrans )

=== src/trans/common/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

# Preprocess module file containing version information
configure_file( internal/ectrans_version_mod.F90.in internal/ectrans_version_mod.F90 )

## Sources which are precision independent can go into a common library
list( APPEND ectrans_common_src
  sharedmem/sharedmem_mod.F90
  sharedmem/sharedmem.c
  internal/ectrans_blas_mod.F90
  internal/abort_trans_mod.F90
  internal/cpledn_mod.F90
  internal/field_split_mod.F90
  internal/gawl_mod.F90
  internal/interpol_decomp_mod.F90
  internal/sugaw_mod.F90
  internal/supol_mod.F90
  internal/supolf_mod.F90
  internal/tpm_constants.F90
  internal/tpm_ctl.F90
  internal/tpm_dim.F90
  internal/tpm_fields.F90
  internal/tpm_gen.F90
  internal/tpm_geometry.F90
  internal/tpm_pol.F90
  internal/tpm_distr.F90
  internal/pe2set_mod.F90
  internal/set2pe_mod.F90
  internal/eq_regions_mod.F90
  internal/pre_suleg_mod.F90
  internal/setup_dims_mod.F90
  internal/setup_geom_mod.F90
  internal/shuffle_mod.F90
  internal/sump_trans0_mod.F90
  internal/sustaonl_mod.F90
  internal/sumplat_mod.F90
  internal/sumplatb_mod.F90
  internal/sumplatbeq_mod.F90
  internal/sumplatf_mod.F90
  internal/sutrle_mod.F90
  internal/mysendset_mod.F90
  internal/myrecvset_mod.F90
  internal/suwavedi_mod.F90
  internal/sump_trans_preleg_mod.F90
  internal/wts500_mod.F90
  external/get_current.F90
  external/setup_trans0.F90
  external/ini_spec_dist.F90
  ${CMAKE_CURRENT_BINARY_DIR}/internal/ectrans_version_mod.F90
)
list( APPEND ectrans_common_includes
  ectrans/get_current.h
  ectrans/setup_trans0.h
  ectrans/ini_spec_dist.h
)

ecbuild_add_library(
  TARGET           ectrans_common
  LINKER_LANGUAGE  Fortran
  SOURCES          ${ectrans_common_src}
  PUBLIC_LIBS      fiat
  PRIVATE_LIBS     ${LAPACK_LIBRARIES}
  PUBLIC_INCLUDES  $<INSTALL_INTERFACE:include/ectrans>
                   $<INSTALL_INTERFACE:include>
                   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/trans/include/ectrans>
                   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src/trans/include>
)
ectrans_target_fortran_module_directory(
  TARGET            ectrans_common
  MODULE_DIRECTORY  ${CMAKE_BINARY_DIR}/module/ectrans
  INSTALL_DIRECTORY module/ectrans
)

if( HAVE_OMP )
  ecbuild_debug("target_link_libraries( ectrans_common PRIVATE OpenMP::OpenMP_Fortran )")
  target_link_libraries( ectrans_common PRIVATE OpenMP::OpenMP_Fortran )
endif()

set( ectrans_common_includes ${ectrans_common_includes} PARENT_SCOPE )

=== src/trans/cpu/CMakeLists.txt ===
# (C) Copyright 2020- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

## Apply workarounds for some known compilers

if(CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
  if( CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 8.7 )

    # Fix for IFS "CONGRAD: SPTSV/DPTSV returned non-zero info with crayftn 8.7.7 (cdt/18.12)
    ectrans_add_compile_options(
        SOURCES internal/ftinv_ctlad_mod.F90
        FLAGS   "-O0,fp1,omp")

  endif()
endif()

if(CMAKE_Fortran_COMPILER_ID MATCHES "Intel")
  if( CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 18 AND CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 19 )

    # See https://github.com/ecmwf-ifs/ectrans/issues/17
    ectrans_add_compile_options(
        SOURCES algor/butterfly_alg_mod.F90
        FLAGS   "-check nopointers")
  endif()
endif()


function(generate_backend_sources)
  set (options)
  set (oneValueArgs BACKEND DESTINATION OUTPUT)
  set (multiValueArgs)

  cmake_parse_arguments(_PAR "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN})
  set(backend ${_PAR_BACKEND})
  set(destination ${_PAR_DESTINATION})
  file(MAKE_DIRECTORY ${destination}/algor)
  file(MAKE_DIRECTORY ${destination}/internal)
  file(MAKE_DIRECTORY ${destination}/external)

  ecbuild_list_add_pattern( LIST files
    GLOB
          algor/*.F90
          internal/*.F90
          external/*.F90
    QUIET
  )

  set(outfiles)
  foreach(file_i ${files})
    get_filename_component(outfile_name    ${file_i} NAME)
    get_filename_component(outfile_name_we ${file_i} NAME_WE)
    get_filename_component(outfile_ext     ${file_i} EXT)
    get_filename_component(outfile_dir     ${file_i} DIRECTORY)
    set(outfile "${destination}/${file_i}")
    ecbuild_debug("Generate ${outfile}")
    generate_file(BACKEND ${backend} INPUT ${CMAKE_CURRENT_SOURCE_DIR}/${file_i} OUTPUT ${outfile})
    list(APPEND outfiles ${outfile})
  endforeach(file_i)
  set(${_PAR_OUTPUT} ${outfiles} PARENT_SCOPE)
endfunction(generate_backend_sources)

set( BUILD_INTERFACE_INCLUDE_DIR ${CMAKE_BINARY_DIR}/include/ectrans )

foreach( prec dp sp )
  if( HAVE_${prec} )

    generate_backend_includes(BACKEND ${prec} TARGET ectrans_${prec}_includes DESTINATION ${BUILD_INTERFACE_INCLUDE_DIR} INCLUDE_DIRECTORY ${PROJECT_SOURCE_DIR}/src/trans/include )
    generate_backend_sources( BACKEND ${prec} OUTPUT ectrans_${prec}_src  DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/generated/ectrans_${prec})
    ecbuild_add_library(
      TARGET           ectrans_${prec}
      LINKER_LANGUAGE  Fortran
      SOURCES          ${ectrans_${prec}_src}
      PUBLIC_INCLUDES  $<INSTALL_INTERFACE:include/ectrans>
                       $<INSTALL_INTERFACE:include>
                       $<BUILD_INTERFACE:${BUILD_INTERFACE_INCLUDE_DIR}>
      PUBLIC_LIBS      fiat ectrans_common ectrans_${prec}_includes
    )

    ectrans_target_fortran_module_directory(
      TARGET            ectrans_${prec}
      MODULE_DIRECTORY  ${CMAKE_BINARY_DIR}/module/ectrans
      INSTALL_DIRECTORY module/ectrans
    )

    set( FFTW_LINK PRIVATE )
    if( LAPACK_LIBRARIES MATCHES "mkl" AND NOT FFTW_LIBRARIES MATCHES "mkl" )
        ecbuild_warn( "Danger: Both MKL and FFTW are linked in trans_${prec}. "
                      "No guarantees on link order can be made for the final executable.")
        set( FFTW_LINK PUBLIC ) # Attempt anyway to give FFTW precedence
    endif()
    ecbuild_debug("target_link_libraries( trans_${prec} ${FFTW_LINK} ${FFTW_LIBRARIES} )")
    target_link_libraries( ectrans_${prec} ${FFTW_LINK} ${FFTW_LIBRARIES} )
    target_include_directories( ectrans_${prec} PRIVATE ${FFTW_INCLUDE_DIRS} )
    target_compile_definitions( ectrans_${prec} PRIVATE WITH_FFTW )
    ecbuild_debug("target_link_libraries( ectrans_${prec} PRIVATE ${LAPACK_LIBRARIES} )")
    target_link_libraries( ectrans_${prec} PRIVATE ${LAPACK_LIBRARIES} )

    if( HAVE_OMP )
      ecbuild_debug("target_link_libraries( ectrans_${prec} PRIVATE OpenMP::OpenMP_Fortran )")
      target_link_libraries( ectrans_${prec} PRIVATE OpenMP::OpenMP_Fortran )
    endif()

    if( ECTRANS_HAVE_CONTIGUOUS_ISSUE )
      # See https://github.com/ecmwf-ifs/ectrans/pull/98
      # There is a problem with CONTIGUOUS keyword in dist_spec_control_mod.F90
      ecbuild_debug("target_compile_definitions( ectrans_${prec} PRIVATE CONTIG_BUGGY_COMPILER)")
      target_compile_definitions( ectrans_${prec} PRIVATE CONTIG_BUGGY_COMPILER)
    endif()

    # This interface library is for backward compatibility, and provides the older includes
    ecbuild_add_library( TARGET trans_${prec} TYPE INTERFACE )
    target_include_directories( trans_${prec} INTERFACE $<BUILD_INTERFACE:${BUILD_INTERFACE_INCLUDE_DIR}/trans_${prec}> )
    target_include_directories( trans_${prec} INTERFACE $<INSTALL_INTERFACE:include/ectrans/trans_${prec}> )
    target_link_libraries( trans_${prec} INTERFACE fiat ectrans_${prec} parkind_${prec})
  endif()
endforeach()

## Install trans interface
install( DIRECTORY ${BUILD_INTERFACE_INCLUDE_DIR}/ DESTINATION include/ectrans )

=== debian/changelog ===
ectrans (1.7.0-4) unstable; urgency=medium

  * Add d/gbp.conf
  * Use dh_fortran to get FMODDIR, flags
  * Use pre-computed DEB_HOST_MULTIARCH
  * Move d/watch to v5 syntax
  * Standards-Version: 4.7.3
  * Drop Priority: optional from source in d/control per new policy
  * Include d/salsa-ci.yml

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 13 Jan 2026 17:44:25 +0000

ectrans (1.7.0-3) unstable; urgency=medium

  * Fix d/copyright for licensecheck: use Apache-2.0
  * d/control: include XB-X-ROCm-GPU-Architecture
  * Patch from Cordell Bloor update d/control for ROCm 6.4.3

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 05 Dec 2025 16:24:27 +0000

ectrans (1.7.0-2) unstable; urgency=medium

  * Drop dep on librocsolver-dev. Closes: #1120014

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 20 Nov 2025 11:24:19 +0000

ectrans (1.7.0-1) unstable; urgency=medium

  * New upstream release
  * Shorten description in d/control
  * Move d/watch to version=4 syntax

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 25 Oct 2025 10:31:07 +0100

=== debian/control ===
Source: ectrans
Section: science
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  architecture-is-64-bit,
  dh-fortran (>= 0.34),
  gfortran | fortran-compiler,
  libfckit-dev (>= 0.13.4-2),
  ecbuild (>= 3.3.2),
  chrpath,
  libopenblas-dev [  !alpha !hurd-amd64 ],
  libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
  liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
  mpi-default-dev,
  librocsolver-dev [amd64 arm64],
  libhipblas-dev  [amd64 arm64],
  libhipfft-dev [amd64 arm64],
  librocfft-dev [amd64 arm64],
  hipcc (>= 7.0.2+dfsg-2) [amd64 arm64],
  pkg-rocm-tools (>= 0.9.3~) [amd64 arm64],
  libfftw3-dev,
  libfiat-dev,
  fiat-utils
Standards-Version: 4.7.3
Homepage: https://github.com/ecmwf-ifs/ectrans
Vcs-Browser: https://salsa.debian.org/science-team/ectrans.git
Vcs-Git: https://salsa.debian.org/science-team/ectrans.git -b debian/latest

Package: libectrans-0
Section: libs
Architecture: any
Multi-Arch: same
XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Spherical Harmonics Transforms library
 ecTrans is the global spherical Harmonics transforms library, 
 extracted from the IFS weather model from ECMWF. 
 It uses a hybrid of MPI and OpenMP parallelisation strategies. 
 The package contains both single- and double precision Fortran 
 libraries (trans_sp, trans_dp), as well as a C interface to the
 double-precision version (transi_dp).
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: ectrans-utils
Architecture: any
Multi-Arch: foreign
Depends:  ${shlibs:Depends}, ${misc:Depends}, libectrans-0 (= ${binary:Version}) 
Description: Spherical Harmonics Transforms library - utilities
 ecTrans is the global spherical Harmonics transforms library, 
 extracted from the IFS weather model from ECMWF. 
 It uses a hybrid of MPI and OpenMP parallelisation strategies. 
 The package contains both single- and double precision Fortran 
 libraries (trans_sp, trans_dp), as well as a C interface to 
 the double-precision version (transi_dp).
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libectrans-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Recommends: ecbuild, ${fortran:Recommends}
XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
Depends:  ${misc:Depends}, ${fortran:Depends},
 libectrans-0 (= ${binary:Version}),
 ectrans-utils (= ${binary:Version})
Description: Spherical Harmonics Transforms library - development files
 ecTrans is the global spherical Harmonics transforms library, 
 extracted from the IFS weather model from ECMWF. 
 It uses a hybrid of MPI and OpenMP parallelisation strategies. 
 The package contains both single- and double precision Fortran libraries 
 (trans_sp, trans_dp), as well as a C interface to the 
 double-precision version (transi_dp)
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
INSTDIR:=$(CURDIR)/debian/tmp
CMAKE_DIR:=$(INSTDIR)/$(LIBDIR)/cmake
FMODDIR:=$(shell dh_fortran get_fmoddir)

DEB_CFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/src
DEB_CXXFLAGS_MAINT_APPEND= -I$(CURDIR)/src -I$(CURDIR)/obj-$(DEB_HOST_MULTIARCH)/src
DEB_FFLAGS_MAINT_APPEND= -I$(FMODDIR)

#
# OMP Doesn't appear to work on these archs
ARCH_NO_OMP:= riscv64 sparc64
ENABLE_OMP:=  $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NO_OMP)),Off,On)

ARCH_HIP:= amd64 arm64
ENABLE_HIP:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_HIP)),On,Off)
# HIP options thanks to Cory Bloor: match the math libs ectrans depends on
# "ACC" == HIP, "GPU" == "CUDA"

BUILD_FLAGS = \
	-DENABLE_ETRANS=$(ENABLE_OMP) \
	-DCMAKE_HIP_ARCHITECTURES="$(shell rocm-target-arch --sep ';')"  \
	-DENABLE_GPU=Off \
	-DENABLE_MKL=Off \
	-DENABLE_ACC=$(ENABLE_HIP) \
	-DENABLE_MPI=On \
	-DENABLE_OMP=$(ENABLE_OMP) 

# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

%:
	dh $@ --buildsystem=ecbuild --builddir=debian/build --with fortran

override_dh_auto_configure:
	dh_auto_configure -- ${BUILD_FLAGS} 

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test || true
endif

override_dh_auto_install:
	dh_auto_install
	chrpath -d $(INSTDIR)/usr/bin/ectrans-benchmark*
	chrpath -d $(INSTDIR)/usr/bin/ectrans-lam-* ||  true
	chrpath -d $(INSTDIR)/$(LIBDIR)/*.so*
	# Fix broken paths
	sed -i -e 's%$${_IMPORT_PREFIX}/include/ectrans%/usr/include/${DEB_HOST_MULTIARCH}/ectrans%' \
		$(CMAKE_DIR)/ectrans/ectrans-targets.cmake	
	# Don't ship symlinks

override_dh_fixperms:
	dh_fixperms
	rm debian/libectrans-dev/$(INCDIR)/ectrans/transi.h debian/libectrans-dev/$(INCDIR)/ectrans/version.h
	cp src/transi/version.h src/transi/transi.h debian/libectrans-dev/$(INCDIR)/ectrans 

override_dh_gencontrol:
	dh_gencontrol -- -Vrocm:GPU-Architecture="$(shell rocm-target-arch)"

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/ecmwf-ifs/ectrans
